/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreElementHierarchyCountRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreElementHierarchyCount extends TableImpl<VCoreElementHierarchyCountRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_element_hierarchy_count</code>
     */
    public static final VCoreElementHierarchyCount V_CORE_ELEMENT_HIERARCHY_COUNT = new VCoreElementHierarchyCount();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreElementHierarchyCountRecord> getRecordType() {
        return VCoreElementHierarchyCountRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy_count.key_parent_element</code>.
     */
    public final TableField<VCoreElementHierarchyCountRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy_count.sub_elements</code>.
     */
    public final TableField<VCoreElementHierarchyCountRecord, Long> SUB_ELEMENTS = createField(DSL.name("sub_elements"), SQLDataType.BIGINT, this, "");

    private VCoreElementHierarchyCount(Name alias, Table<VCoreElementHierarchyCountRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreElementHierarchyCount(Name alias, Table<VCoreElementHierarchyCountRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_element_hierarchy_count" as  SELECT key_parent_element,
          count(key_parent_element) AS sub_elements
         FROM common_dd.t_core_element_hierarchy
        GROUP BY key_parent_element;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy_count</code>
     * table reference
     */
    public VCoreElementHierarchyCount(String alias) {
        this(DSL.name(alias), V_CORE_ELEMENT_HIERARCHY_COUNT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy_count</code>
     * table reference
     */
    public VCoreElementHierarchyCount(Name alias) {
        this(alias, V_CORE_ELEMENT_HIERARCHY_COUNT);
    }

    /**
     * Create a <code>common_dd.v_core_element_hierarchy_count</code> table
     * reference
     */
    public VCoreElementHierarchyCount() {
        this(DSL.name("v_core_element_hierarchy_count"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreElementHierarchyCount as(String alias) {
        return new VCoreElementHierarchyCount(DSL.name(alias), this);
    }

    @Override
    public VCoreElementHierarchyCount as(Name alias) {
        return new VCoreElementHierarchyCount(alias, this);
    }

    @Override
    public VCoreElementHierarchyCount as(Table<?> alias) {
        return new VCoreElementHierarchyCount(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyCount rename(String name) {
        return new VCoreElementHierarchyCount(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyCount rename(Name name) {
        return new VCoreElementHierarchyCount(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchyCount rename(Table<?> name) {
        return new VCoreElementHierarchyCount(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount where(Condition condition) {
        return new VCoreElementHierarchyCount(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyCount where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyCount where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyCount where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchyCount where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchyCount whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
